<?php

// +----------------------------------------------------------------------+
// | ImageAlbum version 2.0                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2004 Joachim Fornallaz                            |
// +----------------------------------------------------------------------+
// | This source file is subject to the GPL license.                      |
// +----------------------------------------------------------------------+
// | Authors: Joachim Fornallaz <jf@omnis.ch>                             |
// +----------------------------------------------------------------------+

/* $Id: IAHTML.php,v 1.7 2004/03/10 00:50:27 jfornall Exp $ */

class IAHTML {

	function makeLink($text,$action,$more=array()) {
		return "<a href=\"".IAHTML::linkLocation($action,$more)."\">$text</a>";	
	}
	
	function deleteLinkLocation($action,$more=array()) {
		$link = IAHTML::linkLocation($action,$more);
		return "javascript:confirmToLoadURL('$link','".$GLOBALS['strAlertBeforeDelete']."')";
	}
	
	function linkLocation($action,$more=array()) {
		
		foreach ($more as $key=>$value)
			$add .= "&amp;".$key."=".$value;
					
		return $_SERVER['PHP_SELF'] ."?action=$action$add";		
	}
	
	function makeLinkExternal($text,$file,$more=array()) {
		
		foreach ($more as $key=>$value)
			$add .= $key."=".$value."&amp;";
					
		return "<a href=\"$file?$add\">$text</a>";	
	}
	
	function makePopupLink($text,$file,$more=array()) {
		
		foreach ($more as $key=>$value)
			$add .= $key."=".$value."&amp;";
					
		return "<a href=\"javascript:open_window('$file?$add')\">$text</a>";	
	}
	
	function formStart($hiddenfields=array(),$class=NULL) {
		return IAHTML::formStartGeneric($_SERVER['PHP_SELF'],array("method"=>"post","class"=>$class),$hiddenfields);
	}
	
	function formStartUpload($hiddenfields=array(),$class=NULL) {
		return IAHTML::formStartGeneric($_SERVER['PHP_SELF'],array("method"=>"post","class"=>$class,"enctype"=>"multipart/form-data"),$hiddenfields);
	}
	
	function formStartExternal($file,$hiddenfields=array(),$class=NULL) {
		return IAHTML::formStartGeneric($file,array("method"=>"post","class"=>$class),$hiddenfields);
	}

	function formStartGeneric($file,$attrs,$hiddenfields) {
		
		$classstr = ($class) ? "class=\"$class\"" : "";

		$out = "\n<!-- FORM START -->";
		$out .= "\n<form action=\"$file\"";
		
		foreach ($attrs as $attr => $value) {
			if (strlen($value) > 0)
				$out .= " $attr=\"$value\"";
		}
		
		$out .= ">";
		
		foreach ($hiddenfields as $key=>$value) {
			$out .= "\n<input type=\"hidden\" name=\"$key\" value=\"$value\">";
		}
		
		return $out;
	}
	
	function formEnd() {
		$out = "\n</form>";
		$out .= "\n<!-- FORM END -->";
		return $out;
	}
	
	function tableStart($class,$padding=2,$spacing=0) {
		return "\n<table cellpadding=\"$padding\" cellspacing=\"$spacing\" border=\"0\" class=\"$class\">";
	}

	function tableEnd() {
		return "\n</table>";
	}
	
	function formText($label,$name,$value) {
		return "\n<td class=\"label\">$label:</td><td><input type=\"text\" name=\"form[$name]\" value=\"$value\" class=\"text\"></td>";
	}

	function formTextRaw($label,$name,$value) {
		return "\n<td class=\"label\">$label:</td><td><input type=\"text\" name=\"$name\" value=\"$value\" class=\"text\"></td>";
	}

	function formPassword($label,$name,$value) {
		return "\n<td class=\"label\">$label:</td><td><input type=\"password\" name=\"form[$name]\" value=\"$value\" class=\"text\"></td>";
	}

	function formCheckBox($label,$name,$value,$checked=false) {
		$strChecked = ($checked) ? "checked" : "";
		return "\n<td align=\"right\"><input type=\"checkbox\" name=\"form[$name]\" value=\"$value\" $strChecked></td><td class=\"label\">$label</td>";
	}

	function formCheckBoxUN($label,$name,$value,$checked=false) {
		$strChecked = ($checked) ? "checked" : "";
		return "\n<td align=\"right\"><input type=\"checkbox\" name=\"$name\" value=\"$value\" $strChecked></td><td class=\"label\">$label</td>";
	}

	function formInfo($label,$value) {
		if ($value == "") $value = "&nbsp;";
		return "\n<td class=\"label\">$label:</td><td><div class=\"disabled\">$value</div></td>";
	}

	function formFixValue($label,$name,$value) {
		return "\n<td class=\"label\">$label:</td><td><div class=\"disabled\">$value</div><input type=\"hidden\" name=\"form[$name]\" value=\"$value\"></td>";
	}

	function formTextarea($label,$name,$value,$span=1) {
		return "\n<td class=\"label\" valign=\"top\">$label:</td><td colspan=\"$span\"><textarea class=\"label\" name=\"form[$name]\" rows=\"5\" cols=\"60\">$value</textarea></td>";
	}

	function getFormCheckbox($name,$value,$checked=false) {
		$strChecked = ($checked) ? "checked" : "";
		return "<input type=\"checkbox\" name=\"form[$name]\" value=\"$value\" $strChecked>";
	}

	function getFormCheckboxUN($name,$value,$checked=false) {
		$strChecked = ($checked) ? "checked" : "";
		return "<input type=\"checkbox\" name=\"$name\" value=\"$value\" $strChecked>";
	}

	function getFormPopup($name,$value,$options) {
		$out = "<select name=\"form[$name]\" size=\"1\">";

		foreach ($options as $key=>$val) {
			$selected = ($value == $val) ? " selected" : "";
			$out .= "<option value=\"$val\"$selected>$key</option>";
		}

		$out .= "</select>";
		return $out;
	}
	
	function getYesNoPopup($name,$value) {
		$yesNo = array($GLOBALS['strYes']=>"yes",$GLOBALS['strNo']=>"no");
		return IAHTML::getFormPopup($name,$value,$yesNo);
	}

	function getFixValue($name,$value) {
		return "<div class=\"disabled\">$value</div><input type=\"hidden\" name=\"form[$name]\" value=\"$value\">";
	}
	
	function formPopup($label,$name,$value,$options) {
		$out .= "\n<td class=\"label\">$label:</td><td>".IAHTML::getFormPopup($name,$value,$options)."</td>";
		return $out;
	}
	
	function formButton($buttons) {
		$out = "\n<td colspan=\"2\">";
	//	$out .= "\n<td></td><td>";
		$out .= $buttons;
		$out .= "<td>";
		return $out;
	}
}

?>