<?php

// +----------------------------------------------------------------------+
// | ImageAlbum version 2.0                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2004 Joachim Fornallaz                            |
// +----------------------------------------------------------------------+
// | This source file is subject to the GPL license.                      |
// +----------------------------------------------------------------------+
// | Authors: Joachim Fornallaz <jf@omnis.ch>                             |
// +----------------------------------------------------------------------+

/* $Id: IATable.php,v 1.4 2004/03/10 00:50:27 jfornall Exp $ */

class IATable {

	var $styleclass;	
	var $content = "";
	var $cellCount;
	var $numCellsInRow;

	/**
	 * Contructor
	 */
	function IATable($class="null",$name="table") {
		$this->styleclass = $class;
		$this->cellCount = -1;
		$this->numCellsInRow = 3;
	}
	
	/**
	 * set the number of single cells in a row
	 */
	function setNumCellsInRow($num) {
		if (is_int($num) && $num > 0)
			$this->numCellsInRow = $num;
	}
	
	/**
	 * add header cells
	 */
	function addHeaderLine($text,$style="") {
		$this->content .= "\n<tr>";
		
		if (is_array($text)) {
			foreach($text as $cell)
				$this->content .= "<th colspan=\"1\" class=\"$style\">$cell</th>";
		} else {
			$this->content .= "<th colspan=\"".$this->numCellsInRow."\" class=\"$style\">$text</th>";
			// <img src=\"images/thLeft.gif\" alt=\"\" width=\"9\" height=\"18\" align=\"left\">
			// <img src=\"images/thRight.gif\" alt=\"\" width=\"9\" height=\"18\" align=\"right\">
		}
		
		$this->content .= "</tr>";
	 	$this->cellCount = -1;
	}

	/**
	 * add single cell
	 */
	function addCell($data,$style="cell") {
		$this->cellCount++;

		if ($this->cellCount % $this->numCellsInRow == 0)
			$this->content .= "\n<tr>";
		
		$this->content .= "<td class=\"$style\">$data</td>";
		
		if (($this->cellCount+1) % $this->numCellsInRow == 0)
			$this->content .= "</tr>";
	}

	/**
	 * add "line" break
	 */
	 function addBreak() {
		if (($this->cellCount+1) % $this->numCellsInRow != 0)
			$this->content .= "</tr>";
	 	$this->cellCount = -1;
	 }

	/**
	 * add "line" cell
	 */
	 function addCellLine($data,$style="cell") {
		$this->addBreak();
		$this->content .= "<tr><td colspan=\"".$this->numCellsInRow."\" class=\"$style\">$data</td></tr>";
	 }
	 	
	/**
	 * add regular cells
	 */
	function addLine($data,$action=array(),$keyid="id") {
		$idvalue = NULL;

		if ($this->cellCount % $this->numCellsInRow == 0)
			$this->content .= "\n<tr>";
		
		foreach($data as $key=>$cell) {
			if (is_string($key) && $keyid == $key)
				$idvalue = $cell;
		
			if (is_string($key) && $key == "id")
				$id = $cell;
			elseif (!is_string($key) || $key != "password") {
				$this->content .= "<td>$cell</td>";
				$this->cellCount++;
			}
		}

		$this->content .= $this->actionCell($action,$idvalue);		

		if (($this->cellCount+1) % $this->numCellsInRow == 0)
			$this->content .= "</tr>";
	}
	
	/**
	 * build action cell
	 */
	function actionCell($action,$idvalue) {

		if (count($action) > 0) {
			$out = "<td class=\"action\">";
			$this->cellCount++;
		}

		foreach($action as $key=>$cell) {
			$idstr = ($idvalue) ? "&amp;id=$idvalue" : "";
			$out .= "<a href=\"".$SERVER['PHP_SELF']."?action=$key$idstr\">$cell</a> ";
		}

		if (count($action) > 0)
			$out .= "</td>";
		
		return $out;
	}

	/**
	 *
	 */
	function toHTML($padding=2,$spacing=0) {
		return "\n<table cellpadding=\"$padding\" cellspacing=\"$spacing\" border=\"0\" class=\"$this->styleclass\">$this->content\n</table>";
	}
}

?>