<?php

// +----------------------------------------------------------------------+
// | ImageAlbum version 2.0                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2004 Joachim Fornallaz                            |
// +----------------------------------------------------------------------+
// | This source file is subject to the GPL license.                      |
// +----------------------------------------------------------------------+
// | Authors: Joachim Fornallaz <jf@omnis.ch>                             |
// +----------------------------------------------------------------------+

/* $Id: IAUser.php,v 1.5 2004/03/10 00:50:27 jfornall Exp $ */

require_once("DB.php");

class IAUser {

	var $db;
	var $authenticated = false;
	var $id;
	var $domainID;
	var $username = NULL;
	var $fullname = NULL;
	var $rights = NULL;
	
	/**
	 * Contructor
	 */
	function IAUser($domainID,&$db,$id=NULL) {
		$this->id = $id;
		$this->db = &$db;
		$this->domainID = $domainID;		
		
		if ($id)
			$this->getDataFromDB();
		else
			$this->fullname = "New User";
	}

	/**
	 *
	 */
	function getDataFromDB() {
		$sql = "SELECT * FROM `iauser` WHERE `id` = $this->id";
		$res = $this->db->query($sql);
		$row = $res->fetchRow(DB_FETCHMODE_ASSOC);
		
		$this->rights = $row["rights"];
		$this->fullname = $row["name"];
		$this->username = $row["username"];
		$this->password = $row["password"];
	}
	
	/**
	 * 
	 */
	function authenticate($domainID,$username,$password) {

		$sql = "SELECT * FROM `iauser` WHERE `domain_id` = $domainID AND `username` = '$username' AND `password` = '$password' LIMIT 1";
		$res = $this->db->query($sql);
				
		if ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
			$this->id = $row['id'];
			$this->fullname = $row['name'];
			$this->username = $row['username'];
			$this->rights = $row['rights'];
			$this->authenticated = true;
		}
	}
	
	/**
	 * 
	 */
	function init() {
		$this->authenticated = false;
		$this->id = NULL;
		$this->username = NULL;
		$this->password = NULL;
		$this->fullname = NULL;
		$this->rights = NULL;
	}
	
	/**
	 * 
	 */
	function isAuthenticated() {
		return $this->authenticated;
	}

	/**
	 * 
	 */
	function isAdmin() {
		return ($this->rights == "admin");
	}

	/**
	 * 
	 */
	function fullname() {
		return $this->fullname;
	}

	/**
	 * 
	 */
	function delete($id) {
		if ($id == NULL)
			return;
			
		$sql = "DELETE FROM `iausercollection` WHERE IAUser_id=$id";
		$res = $this->db->query($sql);

		$sql = "DELETE FROM `iauser` WHERE id=$id";
		$res = $this->db->query($sql);
	}

	/**
	 * 
	 */
	function update($form) {
	
		if ($this->id) {
			$sql = "UPDATE `iauser` SET name='$form[name]',rights='$form[rights]',username='$form[username]',password='$form[password]' WHERE `id` = $this->id";
			$res = $this->db->query($sql);
		} else {
			$domainID = $this->domainID;
			$sql = "INSERT INTO `iauser` (domain_id,name,rights,username,password) VALUES ($domainID,'$form[name]','$form[rights]','$form[username]','$form[password]')";
			$res = $this->db->query($sql);

			$sql = "SELECT LAST_INSERT_ID()";
			$res = $this->db->query($sql);
			$row = $res->fetchRow();
		
			$this->id = $row[0];
		}

		$colAll = $this->collectionsAll("id");
		$colRel = $this->collectionsRel("id");

		if (!isset($form[collections]))
			$form[collections] = array();

		foreach ($colAll as $col) {
			if (in_array($col,$form[collections]) && !in_array($col,$colRel)) {
				$sql = "INSERT INTO `iausercollection` (IACollection_id, IAUser_id) VALUES ($col, $this->id)";
				$res = $this->db->query($sql);
			} elseif (!in_array($col,$form[collections]) && in_array($col,$colRel)) {
				$sql = "DELETE FROM `iausercollection` WHERE `IACollection_id` = $col AND `IAUser_id` = $this->id";
				$res = $this->db->query($sql);
			}
		}
	}

	/**
	 * get array of all related collections
	 */
	function collectionsRel($field=NULL) {
		$relCollections = array();

		if ($this->id==NULL)
			return $relCollections;
		
		$sql = "SELECT `iacollection`.* FROM `iacollection`,`iauser`,`iausercollection` WHERE `iacollection`.`id` = `iausercollection`.IACollection_id AND `iauser`.`id` = `iausercollection`.IAUser_id AND `iauser`.`id` = $this->id";
		$res = $this->db->query($sql);
		
		while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC)) {
			$relCollections[] = ($field) ? $row[$field] : $row;
		}
		
		return $relCollections;
	}

	/**
	 * get array of all collections
	 */
	function collectionsAll($field=NULL) {
		$sql = "SELECT * FROM `iacollection` WHERE `domain_id` = $this->domainID";
		$res = $this->db->query($sql);
		$all = array();

		while ($row = $res->fetchRow(DB_FETCHMODE_ASSOC))
			$all[] = ($field) ? $row[$field] : $row;
		
		return $all;
	}
	
	/**
	 * 
	 */
	function userView() {

		$out = "\n<div class=\"navi01\">";
		$out .= IAHTML::makeLink("Users","admin.user.list");
		$out .= " &gt; ".$this->fullname;
		$out .= "</div>";

		$rights = array("Admin"=>"admin","Write"=>"write","Read"=>"read");		

		$out .= IAHTML::formStart(array("id"=>$this->id,"action"=>"admin.user.update"));

		$out .= "\n<div class=\"navi02\">";
		$out .= IAHTML::tableStart("userinfo",3);
		$out .= "<tr><td rowspan=\"4\" valign=\"top\" bgcolor=\"silver\"><img src=\"images/user.gif\" alt=\"Image\" width=\"16\" height=\"16\"></td>";
		$out .= IAHTML::formText("Name","name",$this->fullname);
		$out .= IAHTML::formPopup("Rights","rights",$this->rights,$rights)."</tr>";
		$out .= "<tr>".IAHTML::formText("Login","username",$this->username);
		$out .= IAHTML::formPassword("Password","password",$this->password)."</tr>";
		$out .= "<tr><td colspan=\"4\" class=\"label\"><img border=\"0\" src=\"images/arrowopen.gif\" alt=\"\" width=\"12\" height=\"12\">Collections";

		$relCollections = $this->collectionsRel("id");
		$allCollections = $this->collectionsAll();
		$out .= IAHTML::tableStart("list",4);
	//	$out .= "<tr><th class=\"sub2\" colspan=\"2\">Collections <img src=\"images/shelf.gif\" width=\"16\" height=\"16\" align=\"right\"></th></tr>";
		foreach ($allCollections as $oneColl)
			$out .= "<tr>".IAHTML::formCheckBoxUN($oneColl["name"],"form[collections][]",$oneColl["id"],in_array($oneColl["id"],$relCollections))."</tr>";
		$out .= IAHTML::tableEnd();
		
		$out .= "</td></tr>";
		$out .= "<tr>".IAHTML::formButton("<input type=\"submit\" value=\"Save\" class=\"button\"> <input type=\"reset\" value=\"Reset\" class=\"button\">")."</tr>";
		$out .= IAHTML::tableEnd();
		$out .= "</div>";


		$out .= IAHTML::formEnd();
		
		return $out;
	}

	/**
	 * 
	 */
	function getLoginForm() {
		$out =  "\n<form method=\"post\" action=\"" . $_SERVER['PHP_SELF'] . "\">";
		$out .= "\nUsername:<br>";
		$out .= "\n<input type=\"text\" name=\"form[username]\" class=\"login\"><br>";
		$out .= "\nPassword:<br>";
		$out .= "\n<input type=\"password\" name=\"form[password]\" class=\"login\"><br>";
		$out .= "\n<input type=\"submit\" value=\"Login\" class=\"button\"><br>";
		$out .= "\n<input type=\"hidden\" name=\"action\" value=\"authenticate\">";
		$out .= "\n</form>";
		
		return $out;
	}
}

?>