<?php

// +----------------------------------------------------------------------+
// | ImageAlbum version 2.0                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2004 Joachim Fornallaz                            |
// +----------------------------------------------------------------------+
// | This source file is subject to the GPL license.                      |
// +----------------------------------------------------------------------+
// | Authors: Joachim Fornallaz <jf@omnis.ch>                             |
// +----------------------------------------------------------------------+

/* $Id: index.php,v 1.10 2004/03/10 00:50:27 jfornall Exp $ */

// convenience function for printing variables
function echoVar(&$var) {
	echo "\n<pre>\n";
	print_r($var);
	echo "\n</pre>\n";
}

// convenience function for getting parameters
function getParameter($name) {
	return (isset($_GET[$name]) && strlen($_GET[$name]) > 0) ? $_GET[$name] : $_POST[$name];
}


/* ******************** main code ******************** */


// load config file
if (file_exists("config.dev.inc.php")) {
	include_once("config.dev.inc.php");
} else {
	include_once("config.inc.php");
}
	
// redirect to the correct URL when loading not php files 
if (isset($_SERVER["PATH_INFO"])) {
	$path = $_SERVER["PATH_INFO"];
	$scriptPath = dirname($_SERVER["SCRIPT_NAME"]);
	
	if ($scriptPath == "/")
		$scriptPath = "";
		
	// redirect files to correct location
	if (eregi("(jpeg$|jpg$|gif$|png$|css$|js$|html$|stream.php$|popup.php$)", $path)) {
		$path = preg_replace("/^(\/)([^\/]+)(\/)/i","\\4",$path);
	
		header("Location: ".$scriptPath."/$path?".$_SERVER["QUERY_STRING"]);
		exit();
	} elseif (substr($path, -1) != "/") { // be sure, the PATH_INFO path ends with a '/'
		header("Location: ".$_SERVER["PHP_SELF"]."/?".$_SERVER["QUERY_STRING"]);
		exit();
	}
}

// import classes
require_once("classes/ImageAlbum.php");
require_once("HTML/Template/IT.php");	// PEAR
require_once("lang/".$cfg['language'].".inc.php");

session_start();

// get parameter variables
$id = getParameter('id');
$sub = getParameter('sub');
$sval = getParameter('sval');
$form = getParameter('form');
$action = getParameter('action');

if($action == "destroy")
	session_destroy();

// connect to db, instantiate ImageAlbum object
if (strlen($dbName) == 0)
	$dbName = $dbUsername;
	
if (strlen($dbHost) == 0)
	$dbHost = "localhost";

if(!isset($_SESSION['refPictureAlbum'])) {
	$dsn = "$dbType://$dbUsername:$dbPassword@$dbHost/$dbName";
	$_SESSION['refPictureAlbum'] = new ImageAlbum($dsn,$cfg);
}

$_SESSION['refPictureAlbum']->flow($action,$id,$sub,$sval,$form);

$tpl = new HTML_Template_IT("./appearance");
$tpl->loadTemplatefile($_SESSION['refPictureAlbum']->getTemplate()."/main.template.html", true, true);
$tpl->setVariable("LeftFrame",$_SESSION['refPictureAlbum']->getLeftFrameData());
$tpl->setVariable("MainFrame",$_SESSION['refPictureAlbum']->getMainFrameData());
$tpl->setVariable("Credits",$_SESSION['refPictureAlbum']->getCreditsData());

$tpl->show();

?>
