<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>ImageAlbum - Setup</title>
	<style type="text/css" media="screen">
/* <![CDATA[ */
body
{
	background-color: 	#CCC;
	background-image: 	url(images/logobg.jpg);
	background-repeat: 	no-repeat;
	background-attachment: fixed;
	font-family: 		"Lucida Grande", sans-serif;
	font-size: 			12px;
}


#content h2 {
	margin-top:			0em;
}

h2 {
	font-family: 		"Lucida Grande", sans-serif;
	font-weight: 		bold;
	font-size: 			18px;
	color: 				#333;
	border-bottom:		1px solid gray;
	clear: left;
}

p { clear: left; }

div.code {
	padding: 			0.3em;
	margin-bottom:		0.7em;
	margin-left:		20px;
	border: 			1px solid gray;
	background-color: 	#ddd;
	font-size: 			12px;
	font-family: 		monospace;
	float: 				left;
}

#content {
	background:			url(images/transparent.png);
	position: 			absolute;
	left:				60px;
	top:				150px;
	right:				100px;
	border:				1px solid gray;
	padding:			1em;
}

/* ]]> */
</style>
</head>
<body>
<?php

// +----------------------------------------------------------------------+
// | ImageAlbum version 2.0                                               |
// +----------------------------------------------------------------------+
// | Copyright (c) 2002-2004 Joachim Fornallaz                            |
// +----------------------------------------------------------------------+
// | This source file is subject to the GPL license.                      |
// +----------------------------------------------------------------------+
// | Authors: Joachim Fornallaz <jf@omnis.ch>                             |
// +----------------------------------------------------------------------+

/* $Id: setup.php,v 1.2 2004/03/10 00:50:27 jfornall Exp $ */

include_once("classes/IATest.php");
// load config file
if (file_exists("config.dev.inc.php")) {
	include_once("config.dev.inc.php");
} else {
	include_once("config.inc.php");
}

?>

<div id="content">
	
	<h2>PHP</h2>

	<?php IATest::testPHP(); ?>
	
	<?php IATest::testImageFunctions(); ?>

	<h2>Database</h2>
	
	<?php
		$typeOK = IATest::testDatabaseType($GLOBALS,"dbType");
		
		if ($typeOK)
			$connectionOK = IATest::testDatabaseConnection($GLOBALS,array("dbType","dbHost","dbName","dbUsername","dbPassword"));
		
		if ($typeOK && $connectionOK)
			$tablesOK = IATest::testDatabaseTables($GLOBALS);
			
		if ($typeOK && $connectionOK && $tablesOK)
			IATest::testDefaultDomain($GLOBALS);
	?>
	
	<h2>Application Settings</h2>

	<?php IATest::testLanguage($cfg,"language"); ?>

	<?php IATest::testDatapath($cfg,"datapath"); ?>

	<?php IATest::testDatafolders($cfg,"datafolders"); ?>

	<h2>Domain Administration</h2>

	<?php IATest::testAdminDomain($cfg,array("admindomain","adminlogin","adminpasswd")); ?>

</div>

</body>
</html>
